:- module(backtrack_count, [choicepoint_made/0,choice_made/0,
			    clear_counter/1, get_counter/2,
			    incr_counter/2
			   ]).

% Eggyel cskkenti a visszalps-szmllt.
choicepoint_made :- incr_counter(btracks, -1).

% Eggyel nveli a visszalps-szmllt.
choice_made :- incr_counter(btracks, 1).

% Nullzza a Cnt szmllt.
clear_counter(Cnt) :- bb_put(Cnt, 0).

% A Cnt szmll aktulis rtke V.
get_counter(Cnt, V) :- bb_get(Cnt, V0), !, V = V0.
get_counter(_, 0).

% A Cnt szmll erteket I-vel noveli.
incr_counter(Cnt, Incr) :-
	bb_get(Cnt, Val), !, Val1 is Val+Incr, bb_put(Cnt, Val1).
incr_counter(Cnt, Incr) :-
	bb_put(Cnt, Incr).
